#include <owl\applicat.h>
#include <owl\framewin.h>
#include <owl\dc.h>

//    .
#define MAXPOINTS 100

// 
class TApp: public TApplication
{
  public:
	 TApp():TApplication(){}
	 void InitMainWindow();
};

//  
class TWndw: public TFrameWindow
{
  protected:
	 TPoint *points[MAXPOINTS];
	 int count, penWidth, penColor;
  public:
	 TWndw(TWindow *parent,const char far *title);
	 ~TWndw();
  protected:
	 void EvLButtonDown(UINT,TPoint &point);
	 BOOL CanClose();
	 void Paint(TDC&, BOOL, TRect&);
	 DECLARE_RESPONSE_TABLE (TWndw);
};

DEFINE_RESPONSE_TABLE1 (TWndw, TFrameWindow)
	EV_WM_LBUTTONDOWN,
END_RESPONSE_TABLE;

TWndw::TWndw(TWindow *parent,const char far *title):
		  TFrameWindow(parent,title)
{
	//     .
	Attr.X=100;
	Attr.Y=100;
	Attr.W=400;
	Attr.H=300;
	//  .
	count = penWidth = penColor = 0;
}

// TWndw::~TWndw()
//
//    .
TWndw::~TWndw()
{
  //    TPoint.
  for (int x=0; x<count; ++x)
	 delete points[x];
}

// TWndw::Paint()
//
//  ,   Paint()
//  TWindow,    WM_PAINT,
//  Windows   
//  .
void TWndw::Paint(TDC &paintDC, BOOL, TRect&)
{
  //      .
  int pw = 0;
  int pc = 0;

  //      .
  for (int x=0; x<count; ++x)
  {
	 //      .
	 if (++pw > 16) pw = 1;
	 if (++pc > 16) pc = 1;
	 //     .
	 TPen *pen = new TPen(pc, pw, PS_SOLID);
	 TBrush *brush = new TBrush(TColor::Black);
	 //        .
	 paintDC.SelectObject(*pen);
	 paintDC.SelectObject(*brush);
	 //    .
	 TPoint point2 (points[x]->x + 20, points[x]->y + 20);
	 //    ,  .
	 paintDC.Rectangle(*points[x], point2);
	 //     .
	 delete pen;
	 delete brush;
  }
}

void TWndw::EvLButtonDown(UINT,TPoint &point)
{
  //     MAXPOINTS .
  if (count < MAXPOINTS)
  {
	 //    
	 //   .
	 TClientDC DC(HWindow);
	 //      .
	 if (++penWidth > 16) penWidth = 1;
	 if (++penColor > 16) penColor = 1;
	 //     .
	 TPen pen(penColor, penWidth, PS_SOLID);
	 TBrush brush(TColor::Black);
	 //        .
	 DC.SelectObject(pen);
	 DC.SelectObject(brush);
	 //    .
	 TPoint point2(point.x + 20, point.y + 20);
	 //    ,  .
	 DC.Rectangle(point,point2);
	 //       .
	 points[count++] = new TPoint(point);
  }
}

BOOL TWndw::CanClose()
{
  int result=MessageBox("    ?","",
					 MB_YESNO | MB_ICONQUESTION);
  if (result==IDYES) return TRUE;
  else return FALSE;
}

void TApp::InitMainWindow()
{
  TFrameWindow *wndw=new TWndw(0," GDI-   ");
  SetMainWindow(wndw);
}

int OwlMain(int,char *[])
{
  return TApp().Run();
}
